/********************************************************
* Copyright (c) 2011, REDBILLED All Rights Rese_lResulted
*
* THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF REDBILLED
* The copyright notice above does not evidence any actual
* or intended publication of such source code.
* =======================================================
* JNI for the using of PCSC
* =======================================================
* File : PCSC.cpp
*
* List of functions
*	Java_fr_redbilled_security_smartcardio_PCSC_SCardEstablishContext
*	Java_fr_redbilled_security_smartcardio_PCSC_SCardReleaseContext
*	Java_fr_redbilled_security_smartcardio_PCSC_SCardCancel
*	Java_fr_redbilled_security_smartcardio_PCSC_SCardIsValidContext
*	Java_fr_redbilled_security_smartcardio_PCSC_SCardLocateCards
*	Java_fr_redbilled_security_smartcardio_PCSC_SCardListReaders
*	Java_fr_redbilled_security_smartcardio_PCSC_SCardConnect
*	Java_fr_redbilled_security_smartcardio_PCSC_SCardTransmit
*	Java_fr_redbilled_security_smartcardio_PCSC_SCardStatus
*	Java_fr_redbilled_security_smartcardio_PCSC_SCardDisconnect
*	Java_fr_redbilled_security_smartcardio_PCSC_SCardGetStatusChange
*	Java_fr_redbilled_security_smartcardio_PCSC_SCardBeginTransaction
*	Java_fr_redbilled_security_smartcardio_PCSC_SCardEndTransaction
*	Java_fr_redbilled_security_smartcardio_PCSC_SCardControl
*	Java_fr_redbilled_security_smartcardio_PCSC_SCardReconnect
*	Java_fr_redbilled_security_smartcardio_PCSC_SCardGetAttrib
*	Java_fr_redbilled_security_smartcardio_PCSC_SCardSetAttrib
*
* UPDATE HISTORY
*--------------------------------------------------------
*Version | Author     | Date     |
*--------------------------------------------------------
*  1.0	   ML	       22/06/2011
**********************************************************/

#include "../inc/PCSC.h"

#if(defined WIN32) || (defined WIN64)

	#ifdef _MANAGED
	#pragma managed(push, off)
	#endif

	BOOL APIENTRY DllMain( HMODULE hModule,
						   DWORD  ul_reason_for_call,
						   LPVOID lpRese_lResulted
						 )
	{
		switch (ul_reason_for_call)
		{
			case DLL_PROCESS_ATTACH:
				printInDebug("--- Windows PCSC JNI loaded - compiled to %s ---\n", __TIME__);
				break;

			case DLL_THREAD_ATTACH:
				break;

			case DLL_THREAD_DETACH:
				break;

			case DLL_PROCESS_DETACH:
				printInDebug("--- Windows PCSC JNI unloaded ---\n");
				break;
		}
		return TRUE;
	}

	#ifdef _MANAGED
	#pragma managed(pop)
	#endif

#endif // #ifdef WIN32

JNIEXPORT jlong JNICALL Java_fr_redbilled_security_smartcardio_PCSC_SCardEstablishContext(JNIEnv * env, jclass object, jint iScope)
{
	long			_lResult;
	SCARDCONTEXT 	_contextId;
	DWORD			_iScope = iScope;

	printInDebug("--> SCardEstablishContext\n");
	
	switch(_iScope)
	{
		case SCARD_SCOPE_USER:
			printInDebug("SCardEstablishContext scope: SCARD_SCOPE_USER\n");
			break;
			
		case SCARD_SCOPE_SYSTEM:
			printInDebug("SCardEstablishContext scope: SCARD_SCOPE_SYSTEM\n");
			break;
		
		default:
			printInDebug("SCardEstablishContext scope error!\n");
			printInDebug("<-- SCardTransmit Exception: %ld\n", SCARD_E_INVALID_VALUE);
			launchException(env, SCARD_E_INVALID_VALUE);
			return 0;
	}

	_lResult = SCardEstablishContext(_iScope, NULL, NULL, (LPSCARDCONTEXT)&_contextId);
	
	if(_lResult != SCARD_S_SUCCESS)
	{
		printInDebug("ScardEstablishContext failed!\n");
		printInDebug("<-- SCardEstablishContext Exception: %ld\n", _lResult);
		launchException(env, _lResult);
		return 0;
	}
	else
	{
		printInDebug("ScardEstablishContext success 0x%x\n", _contextId);
	}

	printInDebug("<-- SCardEstablishContext\n");
	
	return _contextId;
}

JNIEXPORT void JNICALL Java_fr_redbilled_security_smartcardio_PCSC_SCardReleaseContext(JNIEnv * env, jclass object, jlong lContextId)
{
	long	_lResult;
	
	printInDebug("--> SCardReleaseContext\n");
	
	_lResult = SCardReleaseContext((long)lContextId);
	if(_lResult != SCARD_S_SUCCESS)
	{
		printInDebug("SCardReleaseContext failed!\n");
		printInDebug("<-- SCardReleaseContext Exception: %ld\n", _lResult);
		launchException(env, _lResult);
		return;
	}
	else
	{	
		printInDebug("SCardReleaseContext success\n");
	}
		
	printInDebug("<-- SCardReleaseContext\n");
}

JNIEXPORT void JNICALL Java_fr_redbilled_security_smartcardio_PCSC_SCardCancel(JNIEnv * env, jclass object, jlong lContextId)
{
	long	_lResult;
	
	printInDebug("--> SCardCancel\n");
	
	_lResult = SCardCancel((long)lContextId);
	if(_lResult != SCARD_S_SUCCESS)
	{
		printInDebug("SCardCancel failed!\n");
		printInDebug("<-- SCardCancel Exception: %ld\n", _lResult);
		launchException(env, _lResult);
		return;
	}
	else
	{	
		printInDebug("SCardCancel success\n");
	}
		
	printInDebug("<-- SCardCancel\n");
}

JNIEXPORT void JNICALL Java_fr_redbilled_security_smartcardio_PCSC_SCardIsValidContext(JNIEnv * env, jclass object, jlong lContextId)
{
	long _lResult;

	printInDebug("--> SCardIsValidContext\n");
	
	_lResult = SCardIsValidContext((long)lContextId);

	if(_lResult != SCARD_S_SUCCESS)
	{
		printInDebug("SCardIsValidContext failed!\n");
		printInDebug("<-- SCardIsValidContext Exception: %ld\n", _lResult);
		launchException(env, _lResult);
		return;
	}
	else
	{	
		printInDebug("SCardIsValidContext success\n");
	}
	

	printInDebug("<-- SCardIsValidContext\n");
}

JNIEXPORT jobjectArray JNICALL Java_fr_redbilled_security_smartcardio_PCSC_SCardListReaders(JNIEnv * env, jclass object, jlong lContextId)
{
	long			_lResult;
	LPTSTR			_psReadersList	= NULL;
	DWORD			_lenReadersList;
	DWORD			_i,_j,_z;
	BOOL			_bIsReaderOk = false;
	CHAR			_szReader[NB_MAX_READERS_SUPPORTED][READER_NAME_SZ];
	jobjectArray	_objReturn = NULL;
	
	printInDebug("--> SCardListReaders\n");
	
	_lResult = SCardListReaders((long)lContextId, NULL, NULL, &_lenReadersList);
	if(_lResult != SCARD_S_SUCCESS)
	{
		printInDebug("ScardListReaders failed!\n");
		printInDebug("<-- SCardListReaders Exception: %ld\n", _lResult);
		launchException(env, _lResult);
		return NULL;
	}
	
	printInDebug("ScardListReaders Success with length: %ld!\n", _lenReadersList);

	_psReadersList = (LPTSTR) malloc(_lenReadersList);

	_lResult = SCardListReaders((long)lContextId, NULL, (LPTSTR)_psReadersList, &_lenReadersList);
	if(_lResult != SCARD_S_SUCCESS)
	{
		printInDebug("ScardListReaders failed!\n");
		printInDebug("<-- SCardListReaders Exception: %ld\n", _lResult);
		free(_psReadersList);
		launchException(env, _lResult);
		return NULL;
	}
	else
	{
		for (_i=0; _i < NB_MAX_READERS_SUPPORTED; _i++)
			memset(&_szReader[_i][0],0, sizeof(&_szReader[_i][0]));

		if (_lenReadersList > 2) // \0\0
		{
			_z = 0;
			_j = 0;
			
			for (_i = 0; _i < _lenReadersList; _i =_i + 1)
            {
				memcpy(&_szReader[_j][_z], &_psReadersList[_i], 1);

				if (_psReadersList[_i] == '\0')
				{
					_z = 0;
					_j++;

					if(_i < _lenReadersList-1)
						printInDebug("SCardListReaders New reader found %s\n", _szReader[_j-1]); 
				}
				else
				{
					_z++;
				}
			}
		}
		else
		{
			printInDebug("Scard List Readers failed!\n");
			printInDebug("<-- SCardListReaders Exception: %ld\n", SCARD_E_NO_READERS_AVAILABLE);
			free(_psReadersList);
			launchException(env, SCARD_E_NO_READERS_AVAILABLE);
			return NULL;
		}

		// The last index is just the end of the string not a complete reader name
		_j--;

		printInDebug("SCardListReaders Retrieving Readers Names Success: %d reader(s) found!\n", _j);

		_objReturn = (jobjectArray)env->NewObjectArray(_j, env->FindClass("java/lang/String"), env->NewStringUTF(""));

		for(_i = 0; _i < _j; _i++) 
			env->SetObjectArrayElement(_objReturn, _i, env->NewStringUTF(_szReader[_i]));
	}

	free(_psReadersList);

	printInDebug("<-- SCardListReaders\n");

	return _objReturn;
}

JNIEXPORT jlong JNICALL Java_fr_redbilled_security_smartcardio_PCSC_SCardConnect(JNIEnv *env, jclass object, jlong lContextId, jstring sReaderName, 
																				 jint iShareMode, jint iPreferredProtocols)
{
	long		_lResult;
	SCARDHANDLE _cardHandle;
	DWORD		_activeProtocol;
	const CHAR	*_szReaderName = NULL;
	
	printInDebug("--> SCardConnect\n");
	
	switch(iShareMode)
    {
        case SCARD_SHARE_SHARED:
            printInDebug("SCardConnect SCARD_SHARE_SHARED\n");
            break;

        case SCARD_SHARE_EXCLUSIVE:
            printInDebug("SCardConnect SCARD_SHARE_EXCLUSIVE\n");
            break;

		case SCARD_SHARE_DIRECT:
			printInDebug("SCardConnect SCARD_SHARE_DIRECT\n");
			break;

        default:
            printInDebug("SCardConnect incorrect share mode\n");
            printInDebug("<-- SCardConnect Exception: %ld\n", SCARD_E_INVALID_VALUE);
			launchException(env, SCARD_E_INVALID_VALUE);
            return 0;
    }

    switch(iPreferredProtocols)
    {
		case SCARD_PROTOCOL_UNDEFINED:
			printInDebug("SCardConnect SCARD_PROTOCOL_UNDEFINED\n");
			break;
	
		case SCARD_PROTOCOL_T0:
            printInDebug("SCardConnect SCARD_PROTOCOL_T0\n");
            break;

        case SCARD_PROTOCOL_T1:
            printInDebug("SCardConnect SCARD_PROTOCOL_T1\n");
            break;

        case SCARD_PROTOCOL_T0 | SCARD_PROTOCOL_T1:
            printInDebug("SCardConnect SCARD_PROTOCOL_T0 | SCARD_PROTOCOL_T1\n");
            break;

        default:
            printInDebug("SCardConnect incorrect preferred protocols\n");
            printInDebug("<-- SCardConnect Exception: %ld\n", SCARD_E_INVALID_VALUE);
			launchException(env, SCARD_E_INVALID_VALUE);
			return 0;
    }
	
	_szReaderName = env->GetStringUTFChars((jstring)sReaderName, 0);
	
	printInDebug("SCardConnect %s\n", _szReaderName);
	
	_lResult = SCardConnect((long)lContextId, _szReaderName, iShareMode, iPreferredProtocols, &_cardHandle, &_activeProtocol);
	
	if(_lResult != SCARD_S_SUCCESS)
	{
		printInDebug("SCardConnect failed!\n");
		printInDebug("<-- SCardConnect Exception: %ld\n", _lResult);
		launchException(env, _lResult);
		return 0;
	}
	else
	{	
		printInDebug("SCardConnect success!\n");
		
		// Display the active protocol.
		switch (_activeProtocol)
		{
			case SCARD_PROTOCOL_T0:
				printInDebug("SCardConnect Active protocol T0\n"); 
				break;

			case SCARD_PROTOCOL_T1:
				printInDebug("SCardConnect Active protocol T1\n"); 
				break;

			case SCARD_PROTOCOL_RAW:
				printInDebug("SCardConnect Active protocol RAW\n"); 
				break;

			case SCARD_PROTOCOL_UNDEFINED:
			default:
				printInDebug("SCardConnect Active protocol unnegotiated or unknown\n"); 
				break;
		}
	}

	printInDebug("<-- SCardConnect\n");

	return _cardHandle;
}

JNIEXPORT jbyteArray JNICALL Java_fr_redbilled_security_smartcardio_PCSC_SCardTransmit(JNIEnv *env, jclass object, jlong lCardHandle, jint iProtocol, 
																					   jbyteArray pBCommand, jint iOffset, jint iLength)

{
	long					_lResult;
	BYTE					_pBResponse[BUFFER_MAX_SZ];
	LPSCARD_IO_REQUEST		_protocolResponse = NULL;
	LPCSCARD_IO_REQUEST		_protocolCurrent;
	DWORD					_dwLength = BUFFER_MAX_SZ;
	jbyteArray				_objReturn = NULL;
	BYTE					*_pBCommand;
	
	printInDebug("--> SCardTransmit\n");

	_pBCommand = (BYTE *) (env)->GetByteArrayElements(pBCommand, NULL);

	switch(iProtocol)
	{
		case SCARD_PROTOCOL_T0:
			_protocolCurrent = SCARD_PCI_T0;
			printInDebug("SCardTransmit Protocol current: SCARD_PCI_T0\n");
			break;

		case SCARD_PROTOCOL_T1:
			_protocolCurrent = SCARD_PCI_T1;
			printInDebug("SCardTransmit Protocol current: SCARD_PCI_T1\n");
			break;

		case SCARD_PROTOCOL_RAW:
			_protocolCurrent = SCARD_PCI_RAW;
			printInDebug("SCardTransmit Protocol current: SCARD_PCI_RAW\n");
			break;

		default:
			printInDebug("SCardTransmit Protocol error!\n");
			printInDebug("<-- SCardTransmit Exception: %ld\n", SCARD_E_INVALID_VALUE);
			launchException(env, SCARD_E_INVALID_VALUE);
			return NULL;
	}

	printInDebug("SCardTransmit length: %d command: %#x %#x ... %#x %#x\n", iLength, _pBCommand[0], _pBCommand[1], _pBCommand[iLength - 2], _pBCommand[iLength - 1]);

	_lResult = SCardTransmit((long)lCardHandle, _protocolCurrent, _pBCommand, iLength, _protocolResponse, _pBResponse, &_dwLength);
	if(_lResult != SCARD_S_SUCCESS)
	{
		printInDebug("SCardTransmit failed!\n");
		printInDebug("<-- SCardTransmit Exception: %ld\n", _lResult);
		launchException(env, _lResult);
		return NULL;
	}
	else
	{
		printInDebug("SCardTransmit success %d data retrieved\n", _dwLength);

		if(_dwLength > 0)
		{
			_objReturn = (jbyteArray)env->NewByteArray(_dwLength);
			env->SetByteArrayRegion(_objReturn, 0, _dwLength, (jbyte*)_pBResponse);
			printInDebug("SCardTransmit success card response %d bytes: %#x %#x ... %#x %#x\n", _dwLength, _pBResponse[0], _pBResponse[1], 
				_pBResponse[_dwLength-2], _pBResponse[_dwLength-1]);
		}
		else
		{
			printInDebug("<-- SCardTransmit Invalid card response\n");
			launchException(env, SCARD_E_INVALID_VALUE);
			return NULL;
		}
	}

	(env)->ReleaseByteArrayElements(pBCommand, (jbyte *)_pBCommand, JNI_ABORT);

	printInDebug("<-- SCardTransmit\n");

	return _objReturn;
}

JNIEXPORT jbyteArray JNICALL Java_fr_redbilled_security_smartcardio_PCSC_SCardStatus(JNIEnv *env, jclass object, jlong lCardHandle, 
																					 jbyteArray pBStatus, jobjectArray psReaderNames)
{
	long		_lResult;
	jbyteArray	_objReturn = NULL;
	CHAR		_szReaderName[1][READER_NAME_SZ];
	DWORD		_dwReaderLength = READER_NAME_SZ;
	BYTE		*_pBStatus = (BYTE*)env->GetByteArrayElements(pBStatus, NULL);
	DWORD		_pdwState;
	DWORD		_pdwProtocol;
	BYTE		_pBAtr[ATR_LENGTH];
	DWORD		_dwAtrLength;
		
	printInDebug("--> SCardStatus\n");

	if(env->GetArrayLength(pBStatus) != 2)
	{
		printInDebug("SCardStatus parameter error\n");
		printInDebug("<-- SCardStatus Exception: %ld\n", SCARD_E_INVALID_VALUE);
		launchException(env, SCARD_E_INVALID_VALUE);
		return NULL;
	}
	
	_pdwState = _pBStatus[0];
	_pdwProtocol = _pBStatus[1];

	printInDebug("SCardStatus State %d Protocol %d\n", _pdwState, _pdwProtocol);

	_lResult = SCardStatus((long)lCardHandle, _szReaderName[0], &_dwReaderLength, &_pdwState, &_pdwProtocol, _pBAtr, &_dwAtrLength);
	if(_lResult != SCARD_S_SUCCESS)
	{
		printInDebug("SCardStatus failed!\n");
		printInDebug("<-- SCardStatus Exception: %ld\n", _lResult);
		launchException(env, _lResult);
		return NULL;
	}
	else
	{
		printInDebug("SCardStatus success for reader: %s\n", _szReaderName[0]);

		switch(_pdwState)
		{
			case SCARD_ABSENT:
				printInDebug("SCardStatus state SCARD_ABSENT\n");
				break;

			case SCARD_PRESENT:
				printInDebug("SCardStatus state SCARD_PRESENT\n");
				break;

			case SCARD_SWALLOWED:
				printInDebug("SCardStatus state SCARD_SWALLOWED\n");
				break;

			case SCARD_POWERED:
				printInDebug("SCardStatus state SCARD_POWERED\n");
				break;

			case SCARD_NEGOTIABLE:
				printInDebug("SCardStatus state SCARD_NEGOTIABLE\n");
				break;

			case SCARD_SPECIFIC:
				printInDebug("SCardStatus state SCARD_SPECIFIC\n");
				break;

			case SCARD_UNKNOWN:
				printInDebug("SCardStatus state SCARD_UNKNOWN\n");
				break;
			
			default:
				printInDebug("SCardStatus state error\n");
				printInDebug("<-- SCardStatus Exception: %ld\n", SCARD_E_INVALID_VALUE);
				launchException(env, SCARD_E_INVALID_VALUE);
				return NULL;
		}

		// Display the active protocol.
		switch (_pdwProtocol)
		{
			case SCARD_PROTOCOL_T0:
				printInDebug("SCardStatus Active protocol T0\n"); 
				break;

			case SCARD_PROTOCOL_T1:
				printInDebug("SCardStatus Active protocol T1\n"); 
				break;

			case SCARD_PROTOCOL_RAW:
				printInDebug("SCardStatus Active protocol RAW\n"); 
				break;

			case SCARD_PROTOCOL_UNDEFINED:
			default:
				printInDebug("SCardStatus Active protocol unnegotiated or unknown\n"); 
				break;
		}
		
		if(_dwAtrLength > 0)
		{
			jstring _strFinal;

			printInDebug("SCardStatus ATR %d bytes %#x %#x ... %#x %#x\n", _dwAtrLength, _pBAtr[0], _pBAtr[1], _pBAtr[_dwAtrLength-2], _pBAtr[_dwAtrLength-1]);
			
			_objReturn = (jbyteArray)env->NewByteArray(_dwAtrLength);
			env->SetByteArrayRegion(_objReturn, 0, _dwAtrLength, (jbyte*)_pBAtr);
			
			_pBStatus[0] = (BYTE)_pdwState;
			_pBStatus[1] = (BYTE)_pdwProtocol;
			
			env->SetByteArrayRegion(pBStatus, 0, 1, (jbyte*)_pBStatus);
			env->SetByteArrayRegion(pBStatus, 1, 1, (jbyte*)&_pBStatus[1]);

			printInDebug("SCardStatus %s\n", _szReaderName[0]);
			_strFinal = env->NewStringUTF(_szReaderName[0]);
			env->SetObjectArrayElement(psReaderNames, 0, _strFinal);
		}
		else
		{
			printInDebug("SCardStatus ATR error\n");
			printInDebug("<-- SCardStatus Exception: %ld\n", SCARD_E_INVALID_VALUE);
			launchException(env, SCARD_E_INVALID_VALUE);
			return NULL;
		}
	}

	printInDebug("<-- SCardStatus\n");

	return _objReturn;
}

JNIEXPORT void JNICALL Java_fr_redbilled_security_smartcardio_PCSC_SCardDisconnect(JNIEnv *env, jclass object, jlong lCardHandle, jint iDisposition)
{
	long _lResult;

	printInDebug("--> SCardDisconnect\n");

	switch(iDisposition)
	{
		case SCARD_LEAVE_CARD:
			printInDebug("SCardDisconnect SCARD_LEAVE_CARD\n");
			break;
		
		case SCARD_RESET_CARD:
			printInDebug("SCardDisconnect SCARD_RESET_CARD\n");
			break;

		case SCARD_UNPOWER_CARD:
			printInDebug("SCardDisconnect SCARD_UNPOWER_CARD\n");
			break;

		case SCARD_EJECT_CARD:
			printInDebug("SCardDisconnect PCSC_SCARD_EJECT_CARD\n");
			break;

		default:
			printInDebug("<-- SCardDisconnect Exception: %ld\n", SCARD_E_INVALID_VALUE);
			launchException(env, SCARD_E_INVALID_VALUE);
			return;
	}

	_lResult = SCardDisconnect((long)lCardHandle, iDisposition);
	if(_lResult != SCARD_S_SUCCESS)
	{
		printInDebug("<-- SCardDisconnect Exception: %ld\n", _lResult);
		launchException(env, _lResult);
	}

	printInDebug("<-- SCardDisconnect\n");
}

JNIEXPORT jintArray JNICALL Java_fr_redbilled_security_smartcardio_PCSC_SCardGetStatusChange(JNIEnv *env, jclass object, jlong lContextId, 
																							 jlong lTimeout, jintArray piCurrentState, 
																							 jobjectArray psReaderNames)
{

	long				_lResult;
	SCARDCONTEXT		_contextId = (SCARDCONTEXT)lContextId;
	DWORD				_dwNbElements = env->GetArrayLength(piCurrentState);
	SCARD_READERSTATE	*_readerState = (SCARD_READERSTATE *)malloc(_dwNbElements * sizeof(SCARD_READERSTATE));
	jintArray			_objReturn = (jintArray)env->NewIntArray(_dwNbElements);
	DWORD				_i = 0;
	int					*_piCurrentState = (int*)env->GetIntArrayElements(piCurrentState, NULL);

	printInDebug("--> SCardGetStatusChange context: %ld\n", lContextId);

	memset(_readerState, 0, _dwNbElements * sizeof(SCARD_READERSTATE));
	
	if(_dwNbElements != env->GetArrayLength(piCurrentState))
	{
		printInDebug("<-- SCardGetStatusChange %d - %d Exception: %ld\n", _dwNbElements, env->GetArrayLength(piCurrentState), SCARD_E_INVALID_VALUE);
		launchException(env, SCARD_E_INVALID_VALUE);
		return NULL;
	}

	for(_i = 0; _i < _dwNbElements; _i++)
	{
		printInDebug("SCardGetStatusChange current state:\n");

		if(_piCurrentState[_i] == SCARD_STATE_UNAWARE)
			printInDebug("\tSCARD_STATE_UNAWARE\n");
		if((_piCurrentState[_i] & SCARD_STATE_IGNORE) == SCARD_STATE_IGNORE)
			printInDebug("\tSCARD_STATE_IGNORE\n");
		if((_piCurrentState[_i] & SCARD_STATE_UNAVAILABLE) == SCARD_STATE_UNAVAILABLE)
			printInDebug("\tSCARD_STATE_UNAVAILABLE\n");
		if((_piCurrentState[_i] & SCARD_STATE_EMPTY) == SCARD_STATE_EMPTY)
			printInDebug("\tSCARD_STATE_EMPTY\n");
		if((_piCurrentState[_i] & SCARD_STATE_PRESENT) == SCARD_STATE_PRESENT)
			printInDebug("\tSCARD_STATE_PRESENT\n");
		if((_piCurrentState[_i] & SCARD_STATE_ATRMATCH) == SCARD_STATE_ATRMATCH)
			printInDebug("\tSCARD_STATE_ATRMATCH\n");
		if((_piCurrentState[_i] & SCARD_STATE_EXCLUSIVE) == SCARD_STATE_EXCLUSIVE)
			printInDebug("\tSCARD_STATE_EXCLUSIVE\n");
		if((_piCurrentState[_i] & SCARD_STATE_INUSE) == SCARD_STATE_INUSE)
			printInDebug("\tSCARD_STATE_INUSE\n");
		if((_piCurrentState[_i] & SCARD_STATE_MUTE) == SCARD_STATE_MUTE)
			printInDebug("\tSCARD_STATE_MUTE\n");
		
		
		jobject _jReaderName = env->GetObjectArrayElement(psReaderNames, _i);
		_readerState[_i].szReader = env->GetStringUTFChars((jstring)_jReaderName, 0);
		_readerState[_i].pvUserData = NULL;
		_readerState[_i].dwCurrentState = _piCurrentState[_i];
		_readerState[_i].dwEventState = SCARD_STATE_UNAWARE;
		_readerState[_i].cbAtr = 0;

		printInDebug("SCardGetStatusChange %d reader: %s - current %d - event %d \n", _i, _readerState[_i].szReader, _readerState[_i].dwCurrentState, _readerState[_i].dwEventState);
	}

	env->ReleaseIntArrayElements(piCurrentState, (jint*)_piCurrentState, JNI_ABORT);

	printInDebug("SCardGetStatusChange %d elements ready to test\n", _dwNbElements);

	printInDebug("SCardGetStatusChange timeout: %d \n", lTimeout);

	_lResult = SCardGetStatusChange(_contextId, (long)lTimeout, _readerState, _dwNbElements);

	if(_lResult != SCARD_S_SUCCESS)
	{
		printInDebug("<-- SCardGetStatusChange Exception: %ld\n", _lResult);
		launchException(env, _lResult);
		return NULL;
	}
	else
	{
		printInDebug("SCardGetStatusChange %ld new states retrieved\n", _dwNbElements);
		
		for(_i = 0; _i < _dwNbElements; _i++)
		{
			jint _eventStateTmp;

			_eventStateTmp = ((jint) _readerState[_i].dwEventState);

			printInDebug("SCardGetStatusChange nb bytes atr %d \n", _readerState[_i].cbAtr);
			
			printInDebug("SCardGetStatusChange event state %d: \n", _eventStateTmp);

			if(_eventStateTmp == SCARD_STATE_UNAWARE)
				printInDebug("\tSCARD_STATE_UNAWARE\n");
			if((_eventStateTmp & SCARD_STATE_IGNORE) == SCARD_STATE_IGNORE)
				printInDebug("\tSCARD_STATE_IGNORE\n");
			if((_eventStateTmp & SCARD_STATE_UNAVAILABLE) == SCARD_STATE_UNAVAILABLE)
				printInDebug("\tSCARD_STATE_UNAVAILABLE\n");
			if((_eventStateTmp & SCARD_STATE_EMPTY) == SCARD_STATE_EMPTY)
				printInDebug("\tSCARD_STATE_EMPTY\n");
			if((_eventStateTmp & SCARD_STATE_PRESENT) == SCARD_STATE_PRESENT)
				printInDebug("\tSCARD_STATE_PRESENT\n");
			if((_eventStateTmp & SCARD_STATE_ATRMATCH) == SCARD_STATE_ATRMATCH)
				printInDebug("\tSCARD_STATE_ATRMATCH\n");
			if((_eventStateTmp & SCARD_STATE_EXCLUSIVE) == SCARD_STATE_EXCLUSIVE)
				printInDebug("\tSCARD_STATE_EXCLUSIVE\n");
			if((_eventStateTmp & SCARD_STATE_INUSE) == SCARD_STATE_INUSE)
				printInDebug("\tSCARD_STATE_INUSE\n");
			if((_eventStateTmp & SCARD_STATE_MUTE) == SCARD_STATE_MUTE)
				printInDebug("\tSCARD_STATE_MUTE\n");
			
			env->SetIntArrayRegion(_objReturn, _i, 1, &_eventStateTmp);
		}
	}

	free(_readerState);

	printInDebug("<-- SCardGetStatusChange\n");

	return _objReturn;
}

JNIEXPORT jboolean JNICALL Java_fr_redbilled_security_smartcardio_PCSCPnPThread_SCardPlugAndPlay(JNIEnv *env, jclass object, jlong lContextId, jlong lTimeout)
{

	long				_lResult;
	SCARDCONTEXT		_contextId = (SCARDCONTEXT)lContextId;
	SCARD_READERSTATE	_readerState[1];
	
	
	printInDebug("--> SCardPlugAndPlay context: %ld\n", lContextId);

	if(g_lContextIdForPnPManagement != lContextId)
	{
		_readerState[0].szReader = "\\\\?PnP?\\Notification";
		_readerState[0].pvUserData = NULL;
		_readerState[0].dwCurrentState = SCARD_STATE_UNAWARE;
		_readerState[0].dwEventState = SCARD_STATE_UNAWARE;
		_readerState[0].cbAtr = 0;

		printInDebug("SCardPlugAndPlay timeout: %d \n", lTimeout);

		_lResult = SCardGetStatusChange(_contextId, (long)lTimeout, _readerState, 1);

		if((_lResult != SCARD_S_SUCCESS) || ((_readerState[0].dwEventState & SCARD_STATE_UNKNOWN) == SCARD_STATE_UNKNOWN))
		{
			printInDebug("SCardPlugAndPlay native plug and play not supported result: %d & event %d \n", _lResult, _readerState[0].dwEventState);
			g_bPnP = false;
		}
		else
		{
			printInDebug("SCardPlugAndPlay native plug and play is supported \n");
			g_bPnP = true;
		}

		g_lContextIdForPnPManagement = (long)lContextId;
		g_lEventOccured = _readerState[0].dwEventState;
	}

	if(g_bPnP)
	{
		_readerState[0].szReader = "\\\\?PnP?\\Notification";
		_readerState[0].pvUserData = NULL;
		_readerState[0].dwCurrentState = g_lEventOccured;
		_readerState[0].dwEventState = SCARD_STATE_UNAWARE;
		_readerState[0].cbAtr = 0;
		
		_lResult = SCardGetStatusChange(_contextId, (long)lTimeout, _readerState, 1);

		if(_lResult == SCARD_E_TIMEOUT)
		{
			printInDebug("<-- SCardPlugAndPlay SCARD_E_TIMEOUT\n");	
			return false;
		}
		else if(_lResult == SCARD_S_SUCCESS)
		{
			printInDebug("<-- SCardPlugAndPlay SCARD_S_SUCCESS\n");		
			g_lEventOccured = _readerState[0].dwEventState;
			return true;
		}
		else
		{
			printInDebug("<-- SCardPlugAndPlay Exception: %ld\n", _lResult);
			launchException(env, _lResult);
			return false;
		}
	}
	else
	{
		printInDebug("<-- SCardPlugAndPlay WARNING NOT IMPLEMENTED\n");
	}
	
	return false;
}

JNIEXPORT jintArray JNICALL Java_fr_redbilled_security_smartcardio_PCSC_SCardLocateCards(JNIEnv *env, jclass object, jlong lContextId, 
																						 jobjectArray psCardNames, jintArray piCurrentState, 
																						 jobjectArray psReaderNames)
{
	/*long _lResult;

	printInDebug("--> SCardLocateCards\n");

	_lResult = SCardLocateCards((long)lContextId, 

	if(_lResult != SCARD_S_SUCCESS)
	{
		printInDebug("<-- SCardLocateCards Exception: %ld\n", _lResult);
		launchException(env, _lResult);
		return NULL;
	}
	else
	{
		printInDebug("SCardLocateCards success\n");
	}

	printInDebug("<-- SCardLocateCards\n");*/

	return NULL;
}

JNIEXPORT void JNICALL Java_fr_redbilled_security_smartcardio_PCSC_SCardBeginTransaction(JNIEnv *env, jclass object, jlong lCardHandle)
{
	long _lResult;

	printInDebug("--> SCardBeginTransaction\n");

	_lResult = SCardBeginTransaction((long)lCardHandle);

	if(_lResult != SCARD_S_SUCCESS)
	{
		printInDebug("<-- SCardBeginTransaction Exception: %ld\n", _lResult);
		launchException(env, _lResult);
		return;
	}
	else
	{
		printInDebug("SCardBeginTransaction success\n");
	}
	
	printInDebug("<-- SCardBeginTransaction\n");
}

JNIEXPORT void JNICALL Java_fr_redbilled_security_smartcardio_PCSC_SCardEndTransaction(JNIEnv *env, jclass object, jlong lCardHandle, 
																					   jint iDisposition)
{
	long _lResult;

	printInDebug("--> SCardEndTransaction\n");

	switch(iDisposition)
	{
		case SCARD_EJECT_CARD:
			printInDebug("SCardEndTransaction SCARD_EJECT_CARD\n");
			break;

		case SCARD_LEAVE_CARD:
			printInDebug("SCardEndTransaction SCARD_LEAVE_CARD\n");
			break;

		case SCARD_RESET_CARD:
			printInDebug("SCardEndTransaction SCARD_RESET_CARD\n");
			break;

		case SCARD_UNPOWER_CARD:
			printInDebug("SCardEndTransaction SCARD_UNPOWER_CARD\n");
			break;

		default:
			printInDebug("<-- SCardEndTransaction Exception: %ld\n", SCARD_E_INVALID_VALUE);
			launchException(env, SCARD_E_INVALID_VALUE);
			return;
	}

	_lResult = SCardEndTransaction((long)lCardHandle, iDisposition);

	if(_lResult != SCARD_S_SUCCESS)
	{
		printInDebug("<-- SCardEndTransaction Exception: %ld\n", _lResult);
		launchException(env, _lResult);
		return;
	}
	else
	{
		printInDebug("SCardEndTransaction success\n");
	}
	
	printInDebug("<-- SCardEndTransaction\n");
}


JNIEXPORT jbyteArray JNICALL Java_fr_redbilled_security_smartcardio_PCSC_SCardControl(JNIEnv *env, jclass object, jlong lCardHandle, 
																					  jint iControlCode, jbyteArray pBCommand)
{
	SCARDHANDLE     _lCardHandle = (SCARDHANDLE)lCardHandle;
	long            _lResult;
	jbyte*         	_pBCommand = (env)->GetByteArrayElements(pBCommand, NULL);
	jint            _iLength = (env)->GetArrayLength(pBCommand);
	jbyte         	_pBReceptionBuffer[BUFFER_MAX_SZ];
	jint            _iReceptionLength = BUFFER_MAX_SZ;
	ULONG         	_ulReturnedLength = 0;
	jbyteArray     	_objReturn = NULL;

    printInDebug("--> SCardControl\n");

    printInDebug("SCardControl controlCode: %d\n", iControlCode);

	if(_iLength >= 2)
		printInDebug("SCardControl Length %d Command %#x %#x  %#x %#x\n", _iLength, _pBCommand[0], _pBCommand[1], _pBCommand[_iLength - 2], _pBCommand[_iLength - 1]);
	else
		printInDebug("SCardControl Length %d\n", _iLength);

	_lResult = SCardControl(_lCardHandle, iControlCode, _pBCommand, _iLength, _pBReceptionBuffer, _iReceptionLength, &_ulReturnedLength);

    (env)->ReleaseByteArrayElements(pBCommand, _pBCommand, JNI_ABORT);

    if(_lResult != SCARD_S_SUCCESS)
    {
        printInDebug("SCardControl failed\n");
        printInDebug("<-- SCardControl Exception: %ld\n", _lResult);
        launchException(env, _lResult);
		return NULL;
    }
    else
    {
        printInDebug("SCardControl success\n");

        if(_ulReturnedLength > 0)
        {
            printInDebug("SCardControl Length %d Response %#x %#x  %#x %#x\n", _ulReturnedLength, _pBReceptionBuffer[0], _pBReceptionBuffer[1], _pBReceptionBuffer[_ulReturnedLength - 2], _pBReceptionBuffer[_ulReturnedLength - 1]);
        
            _objReturn = (env)->NewByteArray(_ulReturnedLength);
            (env)->SetByteArrayRegion(_objReturn, 0, _ulReturnedLength, _pBReceptionBuffer);    
        }
        else
        {
			printInDebug("SCardControl response empty\n");
        
            /*printInDebug("SCardControl invalid reception length\n");
            printInDebug("<-- SCardControl Exception: %ld\n", SCARD_E_INVALID_VALUE);
			launchException(env, SCARD_E_INVALID_VALUE);
			return NULL;*/
        }
    }

	printInDebug("<-- SCardControl\n");

	return _objReturn;
}

JNIEXPORT jbyteArray JNICALL Java_fr_redbilled_security_smartcardio_PCSC_SCardReconnect(JNIEnv *env, jclass object, jlong lCardHandle, jint iShareMode, jint iPreferredProtocols, jint iInitialization)
{
    long            _lResult;
    DWORD           _dwActiveProtocol;
    jbyteArray     	_objReturn = NULL;

    printInDebug("--> SCardReconnect\n");
	
    switch(iShareMode)
    {
        case SCARD_SHARE_SHARED:
            printInDebug("SCardReconnect SCARD_SHARE_SHARED\n");
            break;

        case SCARD_SHARE_EXCLUSIVE:
            printInDebug("SCardReconnect SCARD_SHARE_EXCLUSIVE\n");
            break;

        default:
            printInDebug("SCardReconnect incorrect share mode\n");
            printInDebug("<-- SCardReconnect Exception: %ld\n", SCARD_E_INVALID_VALUE);
            launchException(env, SCARD_E_INVALID_VALUE);
			return NULL;
    }

    switch(iPreferredProtocols)
    {
        case SCARD_PROTOCOL_T0:
            printInDebug("SCardReconnect SCARD_PROTOCOL_T0\n");
            break;

        case SCARD_PROTOCOL_T1:
            printInDebug("SCardReconnect SCARD_PROTOCOL_T1\n");
            break;

        case SCARD_PROTOCOL_T0 | SCARD_PROTOCOL_T1:
            printInDebug("SCardReconnect SCARD_PROTOCOL_T0 | SCARD_PROTOCOL_T1\n");
            break;

        default:
            printInDebug("SCardReconnect incorrect preferred protocols\n");
            printInDebug("<-- SCardReconnect Exception: %ld\n", SCARD_E_INVALID_VALUE);
            launchException(env, SCARD_E_INVALID_VALUE);
			return NULL;
    }

    switch(iInitialization)
    {
        case SCARD_LEAVE_CARD:
            printInDebug("SCardReconnect SCARD_LEAVE_CARD nothing to do\n");
            break;

        case SCARD_RESET_CARD:
            printInDebug("SCardReconnect SCARD_RESET_CARD => WARM RESET\n");
            break;

        case SCARD_UNPOWER_CARD:
            printInDebug("SCardReconnect SCARD_UNPOWER_CARD => COLD RESET\n");
            break;

        default:
            printInDebug("SCardReconnect incorrect initialization type\n");
            printInDebug("<-- SCardReconnect Exception: %ld\n", SCARD_E_INVALID_VALUE);
            launchException(env, SCARD_E_INVALID_VALUE);
			return NULL;
    }

    _lResult = SCardReconnect((long)lCardHandle, iShareMode, iPreferredProtocols, iInitialization, &_dwActiveProtocol);

    if(_lResult != SCARD_S_SUCCESS)
    {
        printInDebug("SCardReconnect failed\n");
        printInDebug("<-- SCardReconnect Exception: %ld\n", _lResult);
		launchException(env, _lResult);
		return NULL;
    }
    else
    {
        printInDebug("SCardReconnect success\n");

        switch(iPreferredProtocols)
        {
            case SCARD_PROTOCOL_T0:
                printInDebug("SCardReconnect active protocol: SCARD_PROTOCOL_T0\n");
                break;

            case SCARD_PROTOCOL_T1:
                printInDebug("SCardReconnect active protocol: SCARD_PROTOCOL_T1\n");
                break;

            default:
                printInDebug("SCardReconnect incorrect active protocol\n");
                printInDebug("<-- SCardReconnect Exception: %ld\n", SCARD_E_INVALID_VALUE);
				launchException(env, SCARD_E_INVALID_VALUE);
				return NULL;
        }

        // Get the new ATR of the card
		_objReturn = Java_fr_redbilled_security_smartcardio_PCSC_SCardGetAttrib(env, object, lCardHandle, SCARD_ATTR_ATR_STRING);
    }

    printInDebug("<-- SCardReconnect\n");

    return _objReturn;
}

JNIEXPORT jbyteArray JNICALL Java_fr_redbilled_security_smartcardio_PCSC_SCardGetAttrib(JNIEnv *env, jclass object, jlong lCardHandle, 
																						jint iAttribute)
{
	long		_lResult;
	BYTE*		_pBResponse = (BYTE*)malloc(sizeof(BYTE) * BUFFER_MAX_SZ);
	DWORD		_dwAttributeLen = BUFFER_MAX_SZ;
	jbyteArray  _objReturn = NULL;
	
	printInDebug("--> SCardGetAttrib\n");

	switch(iAttribute)
	{
		case SCARD_ATTR_ATR_STRING:
			printInDebug("SCardGetAttrib attribute: SCARD_ATTR_ATR_STRING\n");
			break;

		case SCARD_ATTR_CHANNEL_ID:
			printInDebug("SCardGetAttrib attribute: SCARD_ATTR_CHANNEL_ID\n");
			break;

		case SCARD_ATTR_CHARACTERISTICS:
			printInDebug("SCardGetAttrib attribute: SCARD_ATTR_CHARACTERISTICS\n");
			break;

		case SCARD_ATTR_CURRENT_BWT:
			printInDebug("SCardGetAttrib attribute: SCARD_ATTR_CURRENT_BWT\n");
			break;

		case SCARD_ATTR_CURRENT_CLK:
			printInDebug("SCardGetAttrib attribute: SCARD_ATTR_CURRENT_CLK\n");
			break;

		case SCARD_ATTR_CURRENT_CWT:
			printInDebug("SCardGetAttrib attribute: SCARD_ATTR_CURRENT_CWT\n");
			break;

		case SCARD_ATTR_CURRENT_D:
			printInDebug("SCardGetAttrib attribute: SCARD_ATTR_CURRENT_D\n");
			break;

		case SCARD_ATTR_CURRENT_EBC_ENCODING:
			printInDebug("SCardGetAttrib attribute: SCARD_ATTR_CURRENT_EBC_ENCODING\n");
			break;

		case SCARD_ATTR_CURRENT_F:
			printInDebug("SCardGetAttrib attribute: SCARD_ATTR_CURRENT_F\n");
			break;

		case SCARD_ATTR_CURRENT_IFSC:
			printInDebug("SCardGetAttrib attribute: SCARD_ATTR_CURRENT_IFSC\n");
			break;

		case SCARD_ATTR_CURRENT_IFSD:
			printInDebug("SCardGetAttrib attribute: SCARD_ATTR_CURRENT_IFSD\n");
			break;

		case SCARD_ATTR_CURRENT_N:
			printInDebug("SCardGetAttrib attribute: SCARD_ATTR_CURRENT_N\n");
			break;

		case SCARD_ATTR_CURRENT_PROTOCOL_TYPE:
			printInDebug("SCardGetAttrib attribute: SCARD_ATTR_CURRENT_PROTOCOL_TYPE\n");
			break;

		case SCARD_ATTR_CURRENT_W:
			printInDebug("SCardGetAttrib attribute: SCARD_ATTR_CURRENT_W\n");
			break;

		case SCARD_ATTR_DEFAULT_CLK:
			printInDebug("SCardGetAttrib attribute: SCARD_ATTR_DEFAULT_CLK\n");
			break;

		case SCARD_ATTR_DEFAULT_DATA_RATE:
			printInDebug("SCardGetAttrib attribute: SCARD_ATTR_DEFAULT_DATA_RATE\n");
			break;

		case SCARD_ATTR_DEVICE_FRIENDLY_NAME:
			printInDebug("SCardGetAttrib attribute: SCARD_ATTR_DEVICE_FRIENDLY_NAME\n");
			break;

		case SCARD_ATTR_DEVICE_IN_USE:
			printInDebug("SCardGetAttrib attribute: SCARD_ATTR_DEVICE_IN_USE\n");
			break;

		case SCARD_ATTR_DEVICE_SYSTEM_NAME:
			printInDebug("SCardGetAttrib attribute: SCARD_ATTR_DEVICE_SYSTEM_NAME\n");
			break;

		case SCARD_ATTR_DEVICE_UNIT:
			printInDebug("SCardGetAttrib attribute: SCARD_ATTR_DEVICE_UNIT\n");
			break;

		case SCARD_ATTR_ICC_INTERFACE_STATUS:
			printInDebug("SCardGetAttrib attribute: SCARD_ATTR_ICC_INTERFACE_STATUS\n");
			break;

		case SCARD_ATTR_ICC_PRESENCE:
			printInDebug("SCardGetAttrib attribute: SCARD_ATTR_ICC_PRESENCE\n");
			break;

		case SCARD_ATTR_ICC_TYPE_PER_ATR:
			printInDebug("SCardGetAttrib attribute: SCARD_ATTR_ICC_TYPE_PER_ATR\n");
			break;

		case SCARD_ATTR_MAX_CLK:
			printInDebug("SCardGetAttrib attribute: SCARD_ATTR_MAX_CLK\n");
			break;

		case SCARD_ATTR_MAX_DATA_RATE:
			printInDebug("SCardGetAttrib attribute: SCARD_ATTR_MAX_DATA_RATE\n");
			break;

		case SCARD_ATTR_MAX_IFSD:
			printInDebug("SCardGetAttrib attribute: SCARD_ATTR_MAX_IFSD\n");
			break;

		case SCARD_ATTR_POWER_MGMT_SUPPORT:
			printInDebug("SCardGetAttrib attribute: SCARD_ATTR_POWER_MGMT_SUPPORT\n");
			break;

		case SCARD_ATTR_PROTOCOL_TYPES:
			printInDebug("SCardGetAttrib attribute: SCARD_ATTR_PROTOCOL_TYPES\n");
			break;

		case SCARD_ATTR_VENDOR_IFD_SERIAL_NO:
			printInDebug("SCardGetAttrib attribute: SCARD_ATTR_VENDOR_IFD_SERIAL_NO\n");
			break;

		case SCARD_ATTR_VENDOR_IFD_TYPE:
			printInDebug("SCardGetAttrib attribute: SCARD_ATTR_VENDOR_IFD_TYPE\n");
			break;

		case SCARD_ATTR_VENDOR_IFD_VERSION:
			printInDebug("SCardGetAttrib attribute: SCARD_ATTR_VENDOR_IFD_VERSION\n");
			break;

		case SCARD_ATTR_VENDOR_NAME:
			printInDebug("SCardGetAttrib attribute: SCARD_ATTR_VENDOR_NAME\n");
			break;

		default:
			printInDebug("<-- SCardGetAttrib attribute not supported Exception: %ld\n", SCARD_E_INVALID_VALUE);
			launchException(env, SCARD_E_INVALID_VALUE);
			free(_pBResponse);
			return NULL;
	}

	_lResult = SCardGetAttrib((long)lCardHandle, iAttribute, _pBResponse, &_dwAttributeLen);

	if(_lResult != SCARD_S_SUCCESS)
    {
        printInDebug("SCardGetAttrib failed\n");
        printInDebug("<-- SCardGetAttrib Exception: %ld\n", _lResult);
		launchException(env, _lResult);
		free(_pBResponse);
		return NULL;
    }
    else
    {
		printInDebug("SCardGetAttrib success\n");
		
		if(_dwAttributeLen > 1)
			printInDebug("SCardGetAttrib length %d - %#x %#x ... %#x %#x\n", _dwAttributeLen, _pBResponse[0], _pBResponse[1], _pBResponse[_dwAttributeLen - 2], _pBResponse[_dwAttributeLen - 1]);
		else
			printInDebug("SCardGetAttrib length %d\n", _dwAttributeLen);

		_objReturn = (env)->NewByteArray(_dwAttributeLen);
		(env)->SetByteArrayRegion(_objReturn, 0, _dwAttributeLen, (jbyte*)_pBResponse);
	}

	printInDebug("<-- SCardGetAttrib\n");

	free(_pBResponse);

	return _objReturn;
}

JNIEXPORT void JNICALL Java_fr_redbilled_security_smartcardio_PCSC_SCardSetAttrib(JNIEnv *env, jclass object, jlong lCardHandle, 
																						jint iAttribute, jbyteArray pBAttributeCommand)
{
	long	_lResult;
	BYTE*  _pBCommand = (BYTE*)(env)->GetByteArrayElements(pBAttributeCommand, NULL);
	DWORD	_dwAttributeLength = (env)->GetArrayLength(pBAttributeCommand);

	printInDebug("--> SCardSetAttrib\n");

	switch(iAttribute)
	{
		case(SCARD_ATTR_SUPRESS_T1_IFS_REQUEST):
			break;
		default:
			printInDebug("<-- SCardSetAttrib attribute not supported Exception: %ld\n", SCARD_E_INVALID_VALUE);
			launchException(env, SCARD_E_INVALID_VALUE);
			break;
	}

	if(_dwAttributeLength > 1)
		printInDebug("SCardSetAttrib length %d - %#x %#x ... %#x %#x\n", _dwAttributeLength, _pBCommand[0], _pBCommand[1], _pBCommand[_dwAttributeLength - 2], _pBCommand[_dwAttributeLength - 1]);
	else
		printInDebug("SCardSetAttrib length %d\n", _dwAttributeLength);

	_lResult = SCardSetAttrib((long)lCardHandle, iAttribute, _pBCommand, _dwAttributeLength);

	(env)->ReleaseByteArrayElements(pBAttributeCommand, (jbyte*)_pBCommand, JNI_ABORT);

	if(_lResult != SCARD_S_SUCCESS)
    {
        printInDebug("SCardSetAttrib failed\n");
        printInDebug("<-- SCardSetAttrib Exception: %ld\n", _lResult);
		launchException(env, _lResult);
		return;
    }
    else
    {
		printInDebug("SCardSetAttrib success\n");
	}

	printInDebug("<-- SCardSetAttrib\n");
}

void printInDebug(const char * format, ...)
{
	#if(defined _DEBUG)
		va_list	_arguments;
		time_t	_time;
		char _hour[32];
		int _idRead = 0, _idWrite = 0;
	   	
		// open the debug file
		FILE * _file;
		fopen_s(&_file, "c:\\debugPCSCJNI.log", "a+");
		
		va_start(_arguments, format);
		time(&_time);
		ctime_s(_hour, sizeof(_hour) ,&_time);
		
 		while (_hour[_idRead] != '\0')
 		{
			if (_hour[_idRead] != '\n')
			{
				_hour[_idWrite] = _hour[_idRead];
				_idWrite++;
			}
			_idRead++;
		}
		_hour[_idWrite] = '\0';

		fputs(_hour, _file);
		fputs(" :: ", _file);
		vfprintf(_file, format, _arguments);
		
		// close the debug file
		fclose(_file);		
	#endif
}

void launchException(JNIEnv * env, long lException)
{
	jclass		_pcscClass;
    jmethodID	_constructor;
    jthrowable	_pcscException;

    _pcscClass = env->FindClass(PCSC_EXCEPTION_CLASS);
    _constructor = env->GetMethodID(_pcscClass, "<init>", "(I)V");
    
	_pcscException = (jthrowable) env->NewObject(_pcscClass, _constructor, lException);
	
	env->Throw(_pcscException);
}